<?php

/****************************************************************************

  Copyright (C) 2017-2020  Sendatel S.A.

  This file is part of TUIDD Wordpress SDK.
  TUIDD Wordpress SDK is free software: you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  TUIDD Wordpress SDK is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with TUIDD Wordpress SDK.  If not, see <http://www.gnu.org/licenses/>.

/****************************************************************************/

require_once( 'libs/tuidd_lib/client/TuiddClient.php' );

session_name('sdk-session');
session_start();
//session_name('sdk-session');

if (isset($_GET['code']) && $_GET['code'] != '')
{
	$code = $_GET['code'];
	$tuidd = TuiddClient::getSingleton();

    if ( !$tuidd->hasDiscoveryUrls() ) {
          $tuidd->discovery();
    }

	try {
		$tuidd->getToken($code);
		$tuidd->requestUserInfo();

		$arrStates = $tuidd->readSdkState($_GET['state']);
		$state = $arrStates['client_state'];
		$sdkState = $arrStates['sdk_state'];
		if( strtolower( $sdkState ) == 'binding' )
		{
			$return =json_encode( [ 'status' => 'SUCCESS' ] );
			if ( $tuidd->isDebugging( ) )
			{
				syslog(LOG_INFO, "TUIDD SDK :: ". __METHOD__ ." :: BINDING SUCCESS: ");
			}
			echo $return;
		}
		else
		{
			if ( $tuidd->isDebugging(   ) )
			{
				syslog(LOG_INFO, "TUIDD SDK :: ". __METHOD__ ." :: ACCEDIENDO AL SITIO: ");
			}
            $tuidd->cfReceive();
        }
	}
	catch (Exception $e) {
	    	echo "Tuidd Error: ", $e->getMessage();
	}
}

if( isset( $_GET['action'] ) && $_GET['action'] == 'create_state' )
{
    $tuidd = TuiddClient::getSingleton();
    // FIXME: Configurar la functionCallback de state y nonce y llamaren este punto. JN 2018-06-28
    $state = $tuidd->getState();
    $nonce = $tuidd->getNonce();
    if ($state == '' )
        $tuidd->setState("state");
    if ($nonce == '' )
        $tuidd->setNonce("nonce");

    if ( isset( $_GET['state'] ) && ($_GET['state'] == 'binding' || $_GET['state'] == 'access'  ))
    {        
        if ( isset($_GET['client_id'] ) && $_GET['client_id'] == $tuidd->getClientID() )
        {
            $ret['client_id'] = $tuidd->getClientId();
            $ret['scope'] = $tuidd->getScope();
            $ret['acr_value'] = $tuidd->getSecurityLevel();
            $ret['redirect_uri'] = $tuidd->getRedirectURI();
            $ret['response_type'] = 'code';
            $ret['display'] = 'page';
            $ret['state'] = $tuidd->getState();
            $ret['nonce'] = $tuidd->getNonce();

            echo json_encode($ret);
        }
        else
        {
            $ret['error'] = 'Wrong client_id';
            echo json_encode( $ret );
        }
    }
}
